unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TATransformations, TAChartAxis, TASeries,
  TAChartAxisUtils, Forms,
  Controls, Graphics, Dialogs, ExtCtrls, Buttons, Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    CheckGroup1: TCheckGroup;
    Panel1: TPanel;
    seLinksMax: TSpinEdit;
    seLinksMin: TSpinEdit;
    seRechtsMax: TSpinEdit;
    seRechtsMin: TSpinEdit;
    procedure CheckGroup1ItemClick(Sender: TObject; Index: integer);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SpinEditLinksChange(Sender: TObject);
    procedure SpinEditRechtsChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }
var Chart                 :TChart;
    ChartLS1,ChartLS2     :TLineSeries;
    ChartAxisR            :TChartAxis;
    CAT1,CAT2             :TChartAxisTransformations;
    CATAS1,CATAS2         :TAutoScaleAxisTransform;

procedure TForm1.FormCreate(Sender: TObject);
var i                               :Integer;
    x,y                             :Double;
begin
  seLinksMax.MaxValue:=1500;
  seLinksMax.MinValue:=-100;
  seLinksMax.Increment:=10;
  seLinksMax.Value:=1000;
  seLinksMin.MaxValue:=1500;
  seLinksMin.MinValue:=-100;
  seLinksMin.Increment:=10;
  seLinksMin.Value:=0;
  seRechtsMax.MaxValue:=50;
  seRechtsMax.MinValue:=-20;
  seRechtsMax.Increment:=1;
  seRechtsMax.Value:=25;
  seRechtsMin.MaxValue:=40;
  seRechtsMin.MinValue:=-40;
  seRechtsMin.Increment:=1;
  seRechtsMin.Value:=20;
  CheckGroup1.Items.Add('links');
  CheckGroup1.Items.Add('rechts');
  CheckGroup1.Columns:=2;
  CheckGroup1.Caption:='AutoScale';

  Chart:=TChart.Create(Self);
  Chart.Parent:=Panel1;
  Chart.Align:=alClient;
  Chart.Title.Visible:=True;
  Chart.Title.Font.Color:=clBlack;
  ChartLS1:=TLineSeries.Create(Chart);
  ChartLS1.ShowLines:=True;
  ChartLS1.ShowPoints:=False;
  ChartLS1.LinePen.Color:=clRed;
  ChartLS1.LinePen.Style:=psSolid;
  ChartLS1.AxisIndexX:=1;
  ChartLS1.AxisIndexY:=0;
  Chart.AddSeries(ChartLS1);
  ChartLS2:=TLineSeries.Create(Chart);
  ChartLS2.ShowLines:=True;
  ChartLS2.ShowPoints:=False;
  ChartLS2.LinePen.Color:=clBlue;
  ChartLS2.LinePen.Style:=psSolid;
  ChartLS2.AxisIndexX:=1;
  ChartLS2.AxisIndexY:=2;
  Chart.AddSeries(ChartLS2);
  ChartAxisR:=TChartAxis.Create(Chart.AxisList);
  ChartAxisR.Alignment:=calRight;
  ChartAxisR.Title.Visible:=True;
  ChartAxisR.Title.Caption:='Rechts';
  ChartAxisR.Title.LabelFont.Orientation:=900;
  Chart.AxisList.Axes[0].Title.Visible:=True;
  Chart.AxisList.Axes[0].Title.Caption:='Links';
  Chart.AxisList.Axes[0].Range.UseMin:=True;
  Chart.AxisList.Axes[0].Range.UseMax:=True;
  Chart.AxisList.Axes[0].Range.Min:=seLinksMin.Value;
  Chart.AxisList.Axes[0].Range.Max:=seLinksMax.Value;
  Chart.AxisList.Axes[2].Range.UseMin:=True;
  Chart.AxisList.Axes[2].Range.UseMax:=True;
  Chart.AxisList.Axes[2].Range.Min:=seRechtsMin.Value;
  Chart.AxisList.Axes[2].Range.Max:=seRechtsMax.Value;

  CAT1:=TChartAxisTransformations.Create(Chart);
  CAT2:=TChartAxisTransformations.Create(Chart);
  CATAS1:=TAutoScaleAxisTransform.Create(Chart);
  CATAS2:=TAutoScaleAxisTransform.Create(Chart);
  Chart.AxisList.Axes[0].Transformations:=CAT1;
  Chart.AxisList.Axes[2].Transformations:=CAT2;

  for i:=0 to 100 do begin
    x:=i;
    y:=2*i;
    ChartLS1.AddXY(x,y);
    y:=i*i;
    ChartLS2.AddXY(x,y);
  end;
end;


procedure TForm1.CheckGroup1ItemClick(Sender: TObject; Index: integer);
begin
  if CheckGroup1.Checked[0] then begin
    Chart.AxisList.Axes[0].Range.UseMax:=False;
    Chart.AxisList.Axes[0].Range.UseMin:=False;
  end else begin
    Chart.AxisList.Axes[0].Range.UseMax:=True;
    Chart.AxisList.Axes[0].Range.UseMin:=True;
  end;
  if CheckGroup1.Checked[1] then begin
    Chart.AxisList.Axes[2].Range.UseMax:=False;
    Chart.AxisList.Axes[2].Range.UseMin:=False;
  end else begin
    Chart.AxisList.Axes[2].Range.UseMax:=True;
    Chart.AxisList.Axes[2].Range.UseMin:=True;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Chart.Free;
  //ChartLS1.Free;
  //ChartLS2.Free;
end; {FormClose}

procedure TForm1.SpinEditLinksChange(Sender: TObject);
begin
  Chart.AxisList.Axes[0].Range.Max:=seLinksMax.Value;
  Chart.AxisList.Axes[0].Range.Min:=seLinksMin.Value;
end;

procedure TForm1.SpinEditRechtsChange(Sender: TObject);
begin
  Chart.AxisList.Axes[2].Range.Max:=seRechtsMax.Value;
  Chart.AxisList.Axes[2].Range.Min:=seRechtsMin.Value;
end;

end.

